deps.mk 20 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591
  1. # Copyright (c) 2013-2016, Loïc Hoguin <essen@ninenines.eu>
  2. # This file is part of erlang.mk and subject to the terms of the ISC License.
  3. .PHONY: distclean-deps clean-tmp-deps.log
  4. # Configuration.
  5. ifdef OTP_DEPS
  6. $(warning The variable OTP_DEPS is deprecated in favor of LOCAL_DEPS.)
  7. endif
  8. IGNORE_DEPS ?=
  9. export IGNORE_DEPS
  10. APPS_DIR ?= $(CURDIR)/apps
  11. export APPS_DIR
  12. DEPS_DIR ?= $(CURDIR)/deps
  13. export DEPS_DIR
  14. REBAR_DEPS_DIR = $(DEPS_DIR)
  15. export REBAR_DEPS_DIR
  16. dep_name = $(if $(dep_$(1)),$(1),$(if $(pkg_$(1)_name),$(pkg_$(1)_name),$(1)))
  17. dep_repo = $(patsubst git://github.com/%,https://github.com/%, \
  18. $(if $(dep_$(1)),$(word 2,$(dep_$(1))),$(pkg_$(1)_repo)))
  19. dep_commit = $(if $(dep_$(1)_commit),$(dep_$(1)_commit),$(if $(dep_$(1)),$(word 3,$(dep_$(1))),$(pkg_$(1)_commit)))
  20. ALL_APPS_DIRS = $(if $(wildcard $(APPS_DIR)/),$(filter-out $(APPS_DIR),$(shell find $(APPS_DIR) -maxdepth 1 -type d)))
  21. ALL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(foreach dep,$(filter-out $(IGNORE_DEPS),$(BUILD_DEPS) $(DEPS)),$(call dep_name,$(dep))))
  22. ifeq ($(filter $(APPS_DIR) $(DEPS_DIR),$(subst :, ,$(ERL_LIBS))),)
  23. ifeq ($(ERL_LIBS),)
  24. ERL_LIBS = $(APPS_DIR):$(DEPS_DIR)
  25. else
  26. ERL_LIBS := $(ERL_LIBS):$(APPS_DIR):$(DEPS_DIR)
  27. endif
  28. endif
  29. export ERL_LIBS
  30. export NO_AUTOPATCH
  31. # Verbosity.
  32. dep_verbose_0 = @echo " DEP " $(1);
  33. dep_verbose_2 = set -x;
  34. dep_verbose = $(dep_verbose_$(V))
  35. # Core targets.
  36. ifdef IS_APP
  37. apps::
  38. else
  39. apps:: $(ALL_APPS_DIRS) clean-tmp-deps.log
  40. ifeq ($(IS_APP)$(IS_DEP),)
  41. $(verbose) rm -f $(ERLANG_MK_TMP)/apps.log
  42. endif
  43. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  44. # Create ebin directory for all apps to make sure Erlang recognizes them
  45. # as proper OTP applications when using -include_lib. This is a temporary
  46. # fix, a proper fix would be to compile apps/* in the right order.
  47. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  48. mkdir -p $$dep/ebin || exit $$?; \
  49. done
  50. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  51. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/apps.log; then \
  52. :; \
  53. else \
  54. echo $$dep >> $(ERLANG_MK_TMP)/apps.log; \
  55. $(MAKE) -C $$dep IS_APP=1 || exit $$?; \
  56. fi \
  57. done
  58. endif
  59. clean-tmp-deps.log:
  60. ifeq ($(IS_APP)$(IS_DEP),)
  61. $(verbose) rm -f $(ERLANG_MK_TMP)/deps.log
  62. endif
  63. ifneq ($(SKIP_DEPS),)
  64. deps::
  65. else
  66. deps:: $(ALL_DEPS_DIRS) apps clean-tmp-deps.log
  67. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  68. $(verbose) for dep in $(ALL_DEPS_DIRS) ; do \
  69. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/deps.log; then \
  70. :; \
  71. else \
  72. echo $$dep >> $(ERLANG_MK_TMP)/deps.log; \
  73. if [ -f $$dep/GNUmakefile ] || [ -f $$dep/makefile ] || [ -f $$dep/Makefile ]; then \
  74. $(MAKE) -C $$dep IS_DEP=1 || exit $$?; \
  75. else \
  76. echo "Error: No Makefile to build dependency $$dep."; \
  77. exit 2; \
  78. fi \
  79. fi \
  80. done
  81. endif
  82. # Deps related targets.
  83. # @todo rename GNUmakefile and makefile into Makefile first, if they exist
  84. # While Makefile file could be GNUmakefile or makefile,
  85. # in practice only Makefile is needed so far.
  86. define dep_autopatch
  87. if [ -f $(DEPS_DIR)/$(1)/erlang.mk ]; then \
  88. rm -rf $(DEPS_DIR)/$1/ebin/; \
  89. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  90. $(call dep_autopatch_erlang_mk,$(1)); \
  91. elif [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  92. if [ 0 != `grep -c "include ../\w*\.mk" $(DEPS_DIR)/$(1)/Makefile` ]; then \
  93. $(call dep_autopatch2,$(1)); \
  94. elif [ 0 != `grep -ci "^[^#].*rebar" $(DEPS_DIR)/$(1)/Makefile` ]; then \
  95. $(call dep_autopatch2,$(1)); \
  96. elif [ -n "`find $(DEPS_DIR)/$(1)/ -type f -name \*.mk -not -name erlang.mk -exec grep -i "^[^#].*rebar" '{}' \;`" ]; then \
  97. $(call dep_autopatch2,$(1)); \
  98. fi \
  99. else \
  100. if [ ! -d $(DEPS_DIR)/$(1)/src/ ]; then \
  101. $(call dep_autopatch_noop,$(1)); \
  102. else \
  103. $(call dep_autopatch2,$(1)); \
  104. fi \
  105. fi
  106. endef
  107. define dep_autopatch2
  108. mv -n $(DEPS_DIR)/$1/ebin/$1.app $(DEPS_DIR)/$1/src/$1.app.src; \
  109. rm -f $(DEPS_DIR)/$1/ebin/$1.app; \
  110. if [ -f $(DEPS_DIR)/$1/src/$1.app.src.script ]; then \
  111. $(call erlang,$(call dep_autopatch_appsrc_script.erl,$(1))); \
  112. fi; \
  113. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  114. if [ -f $(DEPS_DIR)/$(1)/rebar -o -f $(DEPS_DIR)/$(1)/rebar.config -o -f $(DEPS_DIR)/$(1)/rebar.config.script ]; then \
  115. $(call dep_autopatch_fetch_rebar); \
  116. $(call dep_autopatch_rebar,$(1)); \
  117. else \
  118. $(call dep_autopatch_gen,$(1)); \
  119. fi
  120. endef
  121. define dep_autopatch_noop
  122. printf "noop:\n" > $(DEPS_DIR)/$(1)/Makefile
  123. endef
  124. # Overwrite erlang.mk with the current file by default.
  125. ifeq ($(NO_AUTOPATCH_ERLANG_MK),)
  126. define dep_autopatch_erlang_mk
  127. echo "include $(call core_relpath,$(dir $(ERLANG_MK_FILENAME)),$(DEPS_DIR)/app)/erlang.mk" \
  128. > $(DEPS_DIR)/$1/erlang.mk
  129. endef
  130. else
  131. define dep_autopatch_erlang_mk
  132. :
  133. endef
  134. endif
  135. define dep_autopatch_gen
  136. printf "%s\n" \
  137. "ERLC_OPTS = +debug_info" \
  138. "include ../../erlang.mk" > $(DEPS_DIR)/$(1)/Makefile
  139. endef
  140. define dep_autopatch_fetch_rebar
  141. mkdir -p $(ERLANG_MK_TMP); \
  142. if [ ! -d $(ERLANG_MK_TMP)/rebar ]; then \
  143. git clone -q -n -- https://github.com/rebar/rebar $(ERLANG_MK_TMP)/rebar; \
  144. cd $(ERLANG_MK_TMP)/rebar; \
  145. git checkout -q 576e12171ab8d69b048b827b92aa65d067deea01; \
  146. $(MAKE); \
  147. cd -; \
  148. fi
  149. endef
  150. define dep_autopatch_rebar
  151. if [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  152. mv $(DEPS_DIR)/$(1)/Makefile $(DEPS_DIR)/$(1)/Makefile.orig.mk; \
  153. fi; \
  154. $(call erlang,$(call dep_autopatch_rebar.erl,$(1))); \
  155. rm -f $(DEPS_DIR)/$(1)/ebin/$(1).app
  156. endef
  157. define dep_autopatch_rebar.erl
  158. application:load(rebar),
  159. application:set_env(rebar, log_level, debug),
  160. rmemo:start(),
  161. Conf1 = case file:consult("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config)") of
  162. {ok, Conf0} -> Conf0;
  163. _ -> []
  164. end,
  165. {Conf, OsEnv} = fun() ->
  166. case filelib:is_file("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)") of
  167. false -> {Conf1, []};
  168. true ->
  169. Bindings0 = erl_eval:new_bindings(),
  170. Bindings1 = erl_eval:add_binding('CONFIG', Conf1, Bindings0),
  171. Bindings = erl_eval:add_binding('SCRIPT', "$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings1),
  172. Before = os:getenv(),
  173. {ok, Conf2} = file:script("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings),
  174. {Conf2, lists:foldl(fun(E, Acc) -> lists:delete(E, Acc) end, os:getenv(), Before)}
  175. end
  176. end(),
  177. Write = fun (Text) ->
  178. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/Makefile)", Text, [append])
  179. end,
  180. Escape = fun (Text) ->
  181. re:replace(Text, "\\\\$$", "\$$$$", [global, {return, list}])
  182. end,
  183. Write("IGNORE_DEPS += edown eper eunit_formatters meck node_package "
  184. "rebar_lock_deps_plugin rebar_vsn_plugin reltool_util\n"),
  185. Write("C_SRC_DIR = /path/do/not/exist\n"),
  186. Write("C_SRC_TYPE = rebar\n"),
  187. Write("DRV_CFLAGS = -fPIC\nexport DRV_CFLAGS\n"),
  188. Write(["ERLANG_ARCH = ", rebar_utils:wordsize(), "\nexport ERLANG_ARCH\n"]),
  189. fun() ->
  190. Write("ERLC_OPTS = +debug_info\nexport ERLC_OPTS\n"),
  191. case lists:keyfind(erl_opts, 1, Conf) of
  192. false -> ok;
  193. {_, ErlOpts} ->
  194. lists:foreach(fun
  195. ({d, D}) ->
  196. Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  197. ({i, I}) ->
  198. Write(["ERLC_OPTS += -I ", I, "\n"]);
  199. ({platform_define, Regex, D}) ->
  200. case rebar_utils:is_arch(Regex) of
  201. true -> Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  202. false -> ok
  203. end;
  204. ({parse_transform, PT}) ->
  205. Write("ERLC_OPTS += +'{parse_transform, " ++ atom_to_list(PT) ++ "}'\n");
  206. (_) -> ok
  207. end, ErlOpts)
  208. end,
  209. Write("\n")
  210. end(),
  211. fun() ->
  212. File = case lists:keyfind(deps, 1, Conf) of
  213. false -> [];
  214. {_, Deps} ->
  215. [begin case case Dep of
  216. {N, S} when is_atom(N), is_list(S) -> {N, {hex, S}};
  217. {N, S} when is_tuple(S) -> {N, S};
  218. {N, _, S} -> {N, S};
  219. {N, _, S, _} -> {N, S};
  220. _ -> false
  221. end of
  222. false -> ok;
  223. {Name, Source} ->
  224. {Method, Repo, Commit} = case Source of
  225. {hex, V} -> {hex, V, undefined};
  226. {git, R} -> {git, R, master};
  227. {M, R, {branch, C}} -> {M, R, C};
  228. {M, R, {ref, C}} -> {M, R, C};
  229. {M, R, {tag, C}} -> {M, R, C};
  230. {M, R, C} -> {M, R, C}
  231. end,
  232. Write(io_lib:format("DEPS += ~s\ndep_~s = ~s ~s ~s~n", [Name, Name, Method, Repo, Commit]))
  233. end end || Dep <- Deps]
  234. end
  235. end(),
  236. fun() ->
  237. case lists:keyfind(erl_first_files, 1, Conf) of
  238. false -> ok;
  239. {_, Files} ->
  240. Names = [[" ", case lists:reverse(F) of
  241. "lre." ++ Elif -> lists:reverse(Elif);
  242. Elif -> lists:reverse(Elif)
  243. end] || "src/" ++ F <- Files],
  244. Write(io_lib:format("COMPILE_FIRST +=~s\n", [Names]))
  245. end
  246. end(),
  247. Write("\n\nrebar_dep: preprocess pre-deps deps pre-app app\n"),
  248. Write("\npreprocess::\n"),
  249. Write("\npre-deps::\n"),
  250. Write("\npre-app::\n"),
  251. PatchHook = fun(Cmd) ->
  252. case Cmd of
  253. "make -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  254. "gmake -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  255. "make " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  256. "gmake " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  257. _ -> Escape(Cmd)
  258. end
  259. end,
  260. fun() ->
  261. case lists:keyfind(pre_hooks, 1, Conf) of
  262. false -> ok;
  263. {_, Hooks} ->
  264. [case H of
  265. {'get-deps', Cmd} ->
  266. Write("\npre-deps::\n\t" ++ PatchHook(Cmd) ++ "\n");
  267. {compile, Cmd} ->
  268. Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  269. {Regex, compile, Cmd} ->
  270. case rebar_utils:is_arch(Regex) of
  271. true -> Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  272. false -> ok
  273. end;
  274. _ -> ok
  275. end || H <- Hooks]
  276. end
  277. end(),
  278. ShellToMk = fun(V) ->
  279. re:replace(re:replace(V, "(\\\\$$)(\\\\w*)", "\\\\1(\\\\2)", [global]),
  280. "-Werror\\\\b", "", [{return, list}, global])
  281. end,
  282. PortSpecs = fun() ->
  283. case lists:keyfind(port_specs, 1, Conf) of
  284. false ->
  285. case filelib:is_dir("$(call core_native_path,$(DEPS_DIR)/$1/c_src)") of
  286. false -> [];
  287. true ->
  288. [{"priv/" ++ proplists:get_value(so_name, Conf, "$(1)_drv.so"),
  289. proplists:get_value(port_sources, Conf, ["c_src/*.c"]), []}]
  290. end;
  291. {_, Specs} ->
  292. lists:flatten([case S of
  293. {Output, Input} -> {ShellToMk(Output), Input, []};
  294. {Regex, Output, Input} ->
  295. case rebar_utils:is_arch(Regex) of
  296. true -> {ShellToMk(Output), Input, []};
  297. false -> []
  298. end;
  299. {Regex, Output, Input, [{env, Env}]} ->
  300. case rebar_utils:is_arch(Regex) of
  301. true -> {ShellToMk(Output), Input, Env};
  302. false -> []
  303. end
  304. end || S <- Specs])
  305. end
  306. end(),
  307. PortSpecWrite = fun (Text) ->
  308. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/c_src/Makefile.erlang.mk)", Text, [append])
  309. end,
  310. case PortSpecs of
  311. [] -> ok;
  312. _ ->
  313. Write("\npre-app::\n\t$$\(MAKE) -f c_src/Makefile.erlang.mk\n"),
  314. PortSpecWrite(io_lib:format("ERL_CFLAGS ?= -finline-functions -Wall -fPIC -I \\"~s/erts-~s/include\\" -I \\"~s\\"\n",
  315. [code:root_dir(), erlang:system_info(version), code:lib_dir(erl_interface, include)])),
  316. PortSpecWrite(io_lib:format("ERL_LDFLAGS ?= -L \\"~s\\" -lerl_interface -lei\n",
  317. [code:lib_dir(erl_interface, lib)])),
  318. [PortSpecWrite(["\n", E, "\n"]) || E <- OsEnv],
  319. FilterEnv = fun(Env) ->
  320. lists:flatten([case E of
  321. {_, _} -> E;
  322. {Regex, K, V} ->
  323. case rebar_utils:is_arch(Regex) of
  324. true -> {K, V};
  325. false -> []
  326. end
  327. end || E <- Env])
  328. end,
  329. MergeEnv = fun(Env) ->
  330. lists:foldl(fun ({K, V}, Acc) ->
  331. case lists:keyfind(K, 1, Acc) of
  332. false -> [{K, rebar_utils:expand_env_variable(V, K, "")}|Acc];
  333. {_, V0} -> [{K, rebar_utils:expand_env_variable(V, K, V0)}|Acc]
  334. end
  335. end, [], Env)
  336. end,
  337. PortEnv = case lists:keyfind(port_env, 1, Conf) of
  338. false -> [];
  339. {_, PortEnv0} -> FilterEnv(PortEnv0)
  340. end,
  341. PortSpec = fun ({Output, Input0, Env}) ->
  342. filelib:ensure_dir("$(call core_native_path,$(DEPS_DIR)/$1/)" ++ Output),
  343. Input = [[" ", I] || I <- Input0],
  344. PortSpecWrite([
  345. [["\n", K, " = ", ShellToMk(V)] || {K, V} <- lists:reverse(MergeEnv(PortEnv))],
  346. case $(PLATFORM) of
  347. darwin -> "\n\nLDFLAGS += -flat_namespace -undefined suppress";
  348. _ -> ""
  349. end,
  350. "\n\nall:: ", Output, "\n\n",
  351. "%.o: %.c\n\t$$\(CC) -c -o $$\@ $$\< $$\(CFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  352. "%.o: %.C\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  353. "%.o: %.cc\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  354. "%.o: %.cpp\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  355. [[Output, ": ", K, " += ", ShellToMk(V), "\n"] || {K, V} <- lists:reverse(MergeEnv(FilterEnv(Env)))],
  356. Output, ": $$\(foreach ext,.c .C .cc .cpp,",
  357. "$$\(patsubst %$$\(ext),%.o,$$\(filter %$$\(ext),$$\(wildcard", Input, "))))\n",
  358. "\t$$\(CC) -o $$\@ $$\? $$\(LDFLAGS) $$\(ERL_LDFLAGS) $$\(DRV_LDFLAGS) $$\(EXE_LDFLAGS)",
  359. case {filename:extension(Output), $(PLATFORM)} of
  360. {[], _} -> "\n";
  361. {_, darwin} -> "\n";
  362. _ -> " -shared\n"
  363. end])
  364. end,
  365. [PortSpec(S) || S <- PortSpecs]
  366. end,
  367. Write("\ninclude $(call core_relpath,$(dir $(ERLANG_MK_FILENAME)),$(DEPS_DIR)/app)/erlang.mk"),
  368. RunPlugin = fun(Plugin, Step) ->
  369. case erlang:function_exported(Plugin, Step, 2) of
  370. false -> ok;
  371. true ->
  372. c:cd("$(call core_native_path,$(DEPS_DIR)/$1/)"),
  373. Ret = Plugin:Step({config, "", Conf, dict:new(), dict:new(), dict:new(),
  374. dict:store(base_dir, "", dict:new())}, undefined),
  375. io:format("rebar plugin ~p step ~p ret ~p~n", [Plugin, Step, Ret])
  376. end
  377. end,
  378. fun() ->
  379. case lists:keyfind(plugins, 1, Conf) of
  380. false -> ok;
  381. {_, Plugins} ->
  382. [begin
  383. case lists:keyfind(deps, 1, Conf) of
  384. false -> ok;
  385. {_, Deps} ->
  386. case lists:keyfind(P, 1, Deps) of
  387. false -> ok;
  388. _ ->
  389. Path = "$(call core_native_path,$(DEPS_DIR)/)" ++ atom_to_list(P),
  390. io:format("~s", [os:cmd("$(MAKE) -C $(call core_native_path,$(DEPS_DIR)/$1) " ++ Path)]),
  391. io:format("~s", [os:cmd("$(MAKE) -C " ++ Path ++ " IS_DEP=1")]),
  392. code:add_patha(Path ++ "/ebin")
  393. end
  394. end
  395. end || P <- Plugins],
  396. [case code:load_file(P) of
  397. {module, P} -> ok;
  398. _ ->
  399. case lists:keyfind(plugin_dir, 1, Conf) of
  400. false -> ok;
  401. {_, PluginsDir} ->
  402. ErlFile = "$(call core_native_path,$(DEPS_DIR)/$1/)" ++ PluginsDir ++ "/" ++ atom_to_list(P) ++ ".erl",
  403. {ok, P, Bin} = compile:file(ErlFile, [binary]),
  404. {module, P} = code:load_binary(P, ErlFile, Bin)
  405. end
  406. end || P <- Plugins],
  407. [RunPlugin(P, preprocess) || P <- Plugins],
  408. [RunPlugin(P, pre_compile) || P <- Plugins],
  409. [RunPlugin(P, compile) || P <- Plugins]
  410. end
  411. end(),
  412. halt()
  413. endef
  414. define dep_autopatch_appsrc_script.erl
  415. AppSrc = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  416. AppSrcScript = AppSrc ++ ".script",
  417. Bindings = erl_eval:new_bindings(),
  418. {ok, Conf} = file:script(AppSrcScript, Bindings),
  419. ok = file:write_file(AppSrc, io_lib:format("~p.~n", [Conf])),
  420. halt()
  421. endef
  422. define dep_autopatch_appsrc.erl
  423. AppSrcOut = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  424. AppSrcIn = case filelib:is_regular(AppSrcOut) of false -> "$(call core_native_path,$(DEPS_DIR)/$1/ebin/$1.app)"; true -> AppSrcOut end,
  425. case filelib:is_regular(AppSrcIn) of
  426. false -> ok;
  427. true ->
  428. {ok, [{application, $(1), L0}]} = file:consult(AppSrcIn),
  429. L1 = lists:keystore(modules, 1, L0, {modules, []}),
  430. L2 = case lists:keyfind(vsn, 1, L1) of {_, git} -> lists:keyreplace(vsn, 1, L1, {vsn, "git"}); _ -> L1 end,
  431. L3 = case lists:keyfind(registered, 1, L2) of false -> [{registered, []}|L2]; _ -> L2 end,
  432. ok = file:write_file(AppSrcOut, io_lib:format("~p.~n", [{application, $(1), L3}])),
  433. case AppSrcOut of AppSrcIn -> ok; _ -> ok = file:delete(AppSrcIn) end
  434. end,
  435. halt()
  436. endef
  437. define dep_fetch_git
  438. git clone -q -n -- $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  439. cd $(DEPS_DIR)/$(call dep_name,$(1)) && git checkout -q $(call dep_commit,$(1));
  440. endef
  441. define dep_fetch_git-submodule
  442. git submodule update --init -- $(DEPS_DIR)/$1;
  443. endef
  444. define dep_fetch_hg
  445. hg clone -q -U $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  446. cd $(DEPS_DIR)/$(call dep_name,$(1)) && hg update -q $(call dep_commit,$(1));
  447. endef
  448. define dep_fetch_svn
  449. svn checkout -q $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  450. endef
  451. define dep_fetch_cp
  452. cp -R $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  453. endef
  454. # Hex only has a package version. No need to look in the Erlang.mk packages.
  455. define dep_fetch_hex
  456. mkdir -p $(ERLANG_MK_TMP)/hex $(DEPS_DIR)/$1; \
  457. $(call core_http_get,$(ERLANG_MK_TMP)/hex/$1.tar,\
  458. https://s3.amazonaws.com/s3.hex.pm/tarballs/$1-$(strip $(word 2,$(dep_$1))).tar); \
  459. tar -xOf $(ERLANG_MK_TMP)/hex/$1.tar contents.tar.gz | tar -C $(DEPS_DIR)/$1 -xzf -;
  460. endef
  461. define dep_fetch_fail
  462. echo "Error: Unknown or invalid dependency: $(1)." >&2; \
  463. exit 78;
  464. endef
  465. # Kept for compatibility purposes with older Erlang.mk configuration.
  466. define dep_fetch_legacy
  467. $(warning WARNING: '$(1)' dependency configuration uses deprecated format.) \
  468. git clone -q -n -- $(word 1,$(dep_$(1))) $(DEPS_DIR)/$(1); \
  469. cd $(DEPS_DIR)/$(1) && git checkout -q $(if $(word 2,$(dep_$(1))),$(word 2,$(dep_$(1))),master);
  470. endef
  471. define dep_fetch
  472. $(if $(dep_$(1)), \
  473. $(if $(dep_fetch_$(word 1,$(dep_$(1)))), \
  474. $(word 1,$(dep_$(1))), \
  475. $(if $(IS_DEP),legacy,fail)), \
  476. $(if $(filter $(1),$(PACKAGES)), \
  477. $(pkg_$(1)_fetch), \
  478. fail))
  479. endef
  480. define dep_target
  481. $(DEPS_DIR)/$(call dep_name,$1):
  482. $(eval DEP_NAME := $(call dep_name,$1))
  483. $(eval DEP_STR := $(if $(filter-out $1,$(DEP_NAME)),$1,"$1 ($(DEP_NAME))"))
  484. $(verbose) if test -d $(APPS_DIR)/$(DEP_NAME); then \
  485. echo "Error: Dependency" $(DEP_STR) "conflicts with application found in $(APPS_DIR)/$(DEP_NAME)."; \
  486. exit 17; \
  487. fi
  488. $(verbose) mkdir -p $(DEPS_DIR)
  489. $(dep_verbose) $(call dep_fetch_$(strip $(call dep_fetch,$(1))),$(1))
  490. $(verbose) if [ -f $(DEPS_DIR)/$(1)/configure.ac -o -f $(DEPS_DIR)/$(1)/configure.in ] \
  491. && [ ! -f $(DEPS_DIR)/$(1)/configure ]; then \
  492. echo " AUTO " $(1); \
  493. cd $(DEPS_DIR)/$(1) && autoreconf -Wall -vif -I m4; \
  494. fi
  495. - $(verbose) if [ -f $(DEPS_DIR)/$(DEP_NAME)/configure ]; then \
  496. echo " CONF " $(DEP_STR); \
  497. cd $(DEPS_DIR)/$(DEP_NAME) && ./configure; \
  498. fi
  499. ifeq ($(filter $(1),$(NO_AUTOPATCH)),)
  500. $(verbose) if [ "$(1)" = "amqp_client" -a "$(RABBITMQ_CLIENT_PATCH)" ]; then \
  501. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  502. echo " PATCH Downloading rabbitmq-codegen"; \
  503. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  504. fi; \
  505. if [ ! -d $(DEPS_DIR)/rabbitmq-server ]; then \
  506. echo " PATCH Downloading rabbitmq-server"; \
  507. git clone https://github.com/rabbitmq/rabbitmq-server.git $(DEPS_DIR)/rabbitmq-server; \
  508. fi; \
  509. ln -s $(DEPS_DIR)/amqp_client/deps/rabbit_common-0.0.0 $(DEPS_DIR)/rabbit_common; \
  510. elif [ "$(1)" = "rabbit" -a "$(RABBITMQ_SERVER_PATCH)" ]; then \
  511. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  512. echo " PATCH Downloading rabbitmq-codegen"; \
  513. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  514. fi \
  515. else \
  516. $$(call dep_autopatch,$(DEP_NAME)) \
  517. fi
  518. endif
  519. endef
  520. $(foreach dep,$(BUILD_DEPS) $(DEPS),$(eval $(call dep_target,$(dep))))
  521. ifndef IS_APP
  522. clean:: clean-apps
  523. clean-apps:
  524. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  525. $(MAKE) -C $$dep clean IS_APP=1 || exit $$?; \
  526. done
  527. distclean:: distclean-apps
  528. distclean-apps:
  529. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  530. $(MAKE) -C $$dep distclean IS_APP=1 || exit $$?; \
  531. done
  532. endif
  533. ifndef SKIP_DEPS
  534. distclean:: distclean-deps
  535. distclean-deps:
  536. $(gen_verbose) rm -rf $(DEPS_DIR)
  537. endif
  538. # Forward-declare variables used in core/deps-tools.mk. This is required
  539. # in case plugins use them.
  540. ERLANG_MK_RECURSIVE_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-deps-list.log
  541. ERLANG_MK_RECURSIVE_DOC_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-doc-deps-list.log
  542. ERLANG_MK_RECURSIVE_REL_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-rel-deps-list.log
  543. ERLANG_MK_RECURSIVE_TEST_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-test-deps-list.log
  544. ERLANG_MK_RECURSIVE_SHELL_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-shell-deps-list.log